#include "morpion.h"
#include<stdio.h>

/**
   Cette fonction initialise une partie de morpion.
   Chaque case de la grille est initialisée à vide.
   @return une structure morpion initialisée
 */
morpion_t creer_partie(){
  morpion_t res;
  int i,j;
  for(i=0;i<3;i++){
    for(j=0;j<3;j++)
      res.tab[i][j]=VIDE;
  }
  res.joueur=CROIX;
  return res;
}

/**
   Permet d'afficher sur le terminal un morpion
   @param m est la grille à afficher
 */
void afficher_morpion(morpion_t m){
  int i,j;
  for(i=0;i<3;i++){
    printf("\t -------\n");
    printf("\t |");
    for(j=0;j<3;j++){
      if(m.tab[i][j]==CROIX)
	printf("X|");
      else if(m.tab[i][j]==ROND)
	printf("O|");
      else
	printf(" |");
    }
    printf("\n");
  }
  printf("\t -------\n");
}

/**
   Elle permet de changer le joueur.
   @param l'intance d'une partie de morpion
 */
void changer_joueur(morpion_t * m){
  m->joueur=(m->joueur+1)%2;
}

/**
   La fonction teste si un joueur à gagné.
   @return 0 si le joueur CROIX a gagné, 1 si le joueur ROND a gagné et 2 sinon.
 */
int game_over(morpion_t m){
  int res=VIDE;
  if(m.tab[0][0]==m.joueur&&m.tab[0][1]==m.joueur&&m.tab[0][2]==m.joueur)
    res=m.joueur;
  if(m.tab[1][0]==m.joueur&&m.tab[1][1]==m.joueur&&m.tab[1][2]==m.joueur)
    res=m.joueur;
  if(m.tab[2][0]==m.joueur&&m.tab[2][1]==m.joueur&&m.tab[2][2]==m.joueur)
    res=m.joueur;
  if(m.tab[0][0]==m.joueur&&m.tab[1][0]==m.joueur&&m.tab[2][0]==m.joueur)
    res=m.joueur;
  if(m.tab[0][1]==m.joueur&&m.tab[1][1]==m.joueur&&m.tab[2][1]==m.joueur)
    res=m.joueur;
  if(m.tab[0][2]==m.joueur&&m.tab[1][2]==m.joueur&&m.tab[2][2]==m.joueur)
    res=m.joueur;
  if(m.tab[0][0]==m.joueur&&m.tab[1][1]==m.joueur&&m.tab[2][2]==m.joueur)
    res=m.joueur;
  if(m.tab[0][2]==m.joueur&&m.tab[1][1]==m.joueur&&m.tab[2][0]==m.joueur)
    res=m.joueur;
  return res;
}


int saisie_coup(){
  int res=-1;
  while(res<0||res>2){
    printf("Entrez une valeur entre 0 et 2: ");
    scanf("%d",&res);
  }
  return res;
}

/**
   Cette fonction demande à un joueur de jouer, vérifie s'il a gagné
   et renvoit la réponse.
   @param m l'instance de la partie de morpion
   @return si le joueur a gagné
 */
int tour(morpion_t * m){
  int ligne,colonne;
  do{
  printf("Entrez la l'indice de la ligne:\n");
  ligne=saisie_coup();
  printf("Entrez la l'indice de la colonne:\n");
  colonne=saisie_coup();
  }while(m->tab[ligne][colonne]!=VIDE);
  m->tab[ligne][colonne]=m->joueur;
  return game_over(*m);
}
