#ifndef _MORPION_H
#define _MORPION_H

#define CROIX 0
#define ROND 1
#define VIDE 2


/**
   La structure morpion contient la grille du jeu en elle même
   et permet d'identifier le joueur qui jouera au tour suivant
 */
struct morpion_s{
  int tab[3][3];
  int joueur;
};
typedef struct morpion_s morpion_t;

/* Déclaration des fonctions */

/**
   Cette fonction initialise une partie de morpion.
   Chaque case de la grille est initialisée à vide.
   @return une structure morpion initialisée
 */
morpion_t creer_partie();

/**
   Permet d'afficher sur le terminal un morpion
   @param m est la grille à afficher
 */
void afficher_morpion(morpion_t m);

/**
   Elle permet de changer le joueur.
   @param l'intance d'une partie de morpion
 */
void changer_joueur(morpion_t * m);

/**
   La fonction teste si un joueur à gagné.
   @return 0 si le joueur CROIX a gagné, 1 si le joueur ROND a gagné et 2 sinon.
 */
int game_over(morpion_t m);


/**
   Cette fonction demande à un joueur de jouer, vérifie s'il a gagné
   et renvoit la réponse.
   @param m l'instance de la partie de morpion
   @return si le joueur a gagné
 */
int tour(morpion_t * m);

#endif
